/**
 ******************************************************************************
 *
 * @file        MG82F6D64_UART0_MID.h
 *
 * @brief       This is the C code format driver file.
 *
 * @par         Project
 *              MG82F6D64
 * @version     V1.13
 * @date        2024/02/23
 * @author      Megawin Software Center
 * @copyright   Copyright (c) 2024 MegaWin Technology Co., Ltd.
 *              All rights reserved.
 *
 ******************************************************************************
 * @par 		Disclaimer
 *		The Demo software is provided "AS IS"  without any warranty, either
 *		expressed or implied, including, but not limited to, the implied warranties
 *		of merchantability and fitness for a particular purpose.  The author will
 *		not be liable for any special, incidental, consequential or indirect
 *		damages due to loss of data or any other reason.
 *		These statements agree with the world wide and local dictated laws about
 *		authorship and violence against these laws.
 ******************************************************************************
 ******************************************************************************
 */

#ifndef MG82F6D64_UART0_MID_H
#define MG82F6D64_UART0_MID_H


///@cond __DRV_URT0_Easy_Wizard_Init
#define OPTION_MATCH 0

#define UART0_8BIT_CONFIG0 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG1 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG2 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG3 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG4 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG5 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG6 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG7 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG8 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG9 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG10 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG11 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG12 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG13 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG14 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG15 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG16 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG17 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG18 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG19 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG20 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG21 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG22 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG23 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG24 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG25 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG26 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG27 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG28 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG29 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG30 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG31 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG32 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG33 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG34 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG35 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG36 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG37 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG38 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG39 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG40 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG41 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG42 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG43 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG44 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG45 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG46 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG47 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG48 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG49 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG50 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG51 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG52 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG53 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG54 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG55 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG56 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG57 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG58 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG59 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG60 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG61 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG62 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG63 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG64 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG65 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG66 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG67 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG68 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG69 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG70 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG71 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG72 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG73 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG74 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG75 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG76 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG77 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG78 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG79 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG80 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG81 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG82 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG83 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG84 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG85 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG86 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG87 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG88 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG89 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG90 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG91 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG92 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG93 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG94 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG95 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG96 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG97 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG98 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG99 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG100 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG101 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG102 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG103 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG104 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG105 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG106 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG107 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG108 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG109 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG110 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG111 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG112 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG113 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG114 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG115 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG116 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG117 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG118 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG119 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG120 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG121 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG122 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG123 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG124 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG125 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_115200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG126 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG127 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG128 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG129 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG130 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG131 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_57600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG132 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG133 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG134 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG135 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG136 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG137 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_19200|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG138 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG139 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG140 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG141 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG142 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)
#define UART0_8BIT_CONFIG143 (UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX|UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_9600|UART0_PIN_CONFIG_RX_P30_TX_P31)

//constant URT0 mode (0~255) option
#define UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX    (0)
#define UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_RX    (0x01000000)
#define UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_LSB_TX_RX (0x02000000)
#define UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX    (0x03000000)
#define UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_RX    (0x04000000)
#define UART0_8BIT_S0BRG_SYSCLK_DIV_1_BAUD_RATE_2X_MSB_TX_RX (0x05000000)
//constant URT0 baud rate(0~255) option
#define UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_9600   (0)
#define UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_19200  (0x00010000)
#define UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_57600  (0x00020000)
#define UART0_8BIT_S0BRG_IHRCO_12MHZ_BAUD_RATE_115200 (0x00030000)
#define UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_115200 (0x00040000)
#define UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_57600 (0x00050000)
#define UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_19200 (0x00060000)
#define UART0_8BIT_S0BRG_IHRCO_110592MHZ_BAUD_RATE_9600 (0x00070000)
#define UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_9600   (0x00080000)
#define UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_19200  (0x00090000)
#define UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_57600  (0x000A0000)
#define UART0_8BIT_S0BRG_IHRCO_24MHZ_BAUD_RATE_115200 (0x000B0000)
#define UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_115200 (0x000C0000)
#define UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_57600 (0x000D0000)
#define UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_19200 (0x000E0000)
#define UART0_8BIT_S0BRG_IHRCO_221184MHZ_BAUD_RATE_9600 (0x000F0000)
#define UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_9600   (0x00100000)
#define UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_19200  (0x00110000)
#define UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_57600  (0x00120000)
#define UART0_8BIT_S0BRG_IHRCO_294912MHZ_BAUD_RATE_115200 (0x00130000)
#define UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_115200 (0x00140000)
#define UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_57600 (0x00150000)
#define UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_19200 (0x00160000)
#define UART0_8BIT_S0BRG_IHRCO_331776MHZ_BAUD_RATE_9600 (0x00170000)
//constant URT0 pin config (0~15) option
#define UART0_PIN_CONFIG_RX_P30_TX_P31 (0)
#define UART0_PIN_CONFIG_RX_P44_TX_P45 (0x00000100)
#define UART0_PIN_CONFIG_RX_P31_TX_P30 (0x00000200)
#define UART0_PIN_CONFIG_RX_P70_TX_P71 (0x00000300)
///@endcond


/**
*******************************************************************************
* @brief        UART0 Easy Wizard
* @details      Set SM30 SM00 SM10 S0DOR SMOD2 SMOD1 SMOD3 S0TX12 S0RCK S0TCK
* @param[in]    __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @return      None
*  @note        None
*  @par         Example
*  @code
                __DRV_URT0_Mode_Easy_Select(UART0_8BIT_CONFIG0)
*  @endcode
*******************************************************************************
*/


#define __DRV_URT0_Mode_Easy_Select(__SELECT__)\
    MWT(\
        __DRV_URT0_EasySetSM30(__SELECT__);\
        __DRV_URT0_EasySetSM00(__SELECT__);\
        __DRV_URT0_EasySetSM10(__SELECT__);\
        __DRV_URT0_EasySetS0DOR(__SELECT__);\
        __DRV_URT0_EasySetSMOD2(__SELECT__);\
        __DRV_URT0_EasySetSMOD1(__SELECT__);\
        __DRV_URT0_EasySetSMOD3(__SELECT__);\
        __DRV_URT0_EasySetS0TX12(__SELECT__);\
        __DRV_URT0_EasySetS0RCK(__SELECT__);\
        __DRV_URT0_EasySetS0TCK(__SELECT__);\
    ;)


/**
*******************************************************************************
* @brief        UART0 Easy Wizard
* @details      Set S0TR S0BRT S0BRC
* @param[in]    __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @return      None
*  @note        None
*  @par         Example
*  @code
                __DRV_URT0_BaudRate_Easy_Select(UART0_8BIT_CONFIG0)
*  @endcode
*******************************************************************************
*/

#define __DRV_URT0_BaudRate_Easy_Select(__SELECT__)\
    MWT(\
        __DRV_URT0_EasySetS0TR_Stop(__SELECT__);\
        __DRV_URT0_EasySetS0BRT(__SELECT__);\
        __DRV_URT0_EasySetS0BRC(__SELECT__);\
        __DRV_URT0_EasySetS0TR_Start(__SELECT__);\
    ;)
/**
*******************************************************************************
* @brief        UART0 PinMux Easy Wizard
* @details      Set S0PS0 S0PS1
* @param[in]    __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @return      None
*  @note        None
*  @par         Example
*  @code
                __DRV_URT0_PinMux_Easy_Select(UART0_8BIT_CONFIG0)
* @endcode
*******************************************************************************
*/

#define __DRV_URT0_PinMux_Easy_Select(__SELECT__)\
    MWT(\
        __DRV_URT0_EasySetS0PS0(__SELECT__);\
        __DRV_URT0_EasySetS0PS1(__SELECT__);\
    ;)
/**
*******************************************************************************
* @brief       UART0 Serial Reception
* @details     Set REN0
* @param[in]  __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @return      None
*  @note        None
*  @par         Example
*  @code
				__DRV_URT0_EasyEnableSerialReception(UART0_8BIT_CONFIG0)
*  @endcode
*******************************************************************************
*/

#define __DRV_URT0_EasyEnableSerialReception(__SELECT__)\
    MWT(\
        ((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT1)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT2)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT3)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT4)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT5)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT6)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT7)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT8)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT9)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT10)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT11)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT12)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT13)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT14)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT15)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT16)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT17)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT18)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT19)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT20)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT21)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT22)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT23)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT24)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT25)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT26)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT27)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT28)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT29)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT30)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT31)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT32)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT33)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT34)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT35)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT36)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT37)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT38)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT39)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT40)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT41)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT42)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT43)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT44)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT45)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT46)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT47)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT48)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT49)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT50)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT51)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT52)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT53)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT54)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT55)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT56)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT57)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT58)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT59)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT60)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT61)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT62)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT63)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT64)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT65)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT66)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT67)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT68)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT69)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT70)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT71)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT72)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT73)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT74)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT75)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT76)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT77)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT78)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT79)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT80)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT81)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT82)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT83)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT84)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT85)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT86)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT87)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT88)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT89)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT90)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT91)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT92)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT93)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT94)==OPTION_MATCH?(REN0=1):\
        (__SELECT__^UART0_SELECT95)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(REN0=1):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(REN0=1):_nop_());\
    ;)
/**
*******************************************************************************
* @brief       UART0 Serial Reception
* @details     Clear REN0
* @param[in]   __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @return      None
*  @note        None
*  @par         Example
*  @code
				__DRV_URT0_EasyDisableSerialReception(UART0_8BIT_CONFIG0)
*  @endcode
*******************************************************************************
*/

#define __DRV_URT0_EasyDisableSerialReception(__SELECT__)\
    MWT(\
		((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT1)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT2)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT3)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT4)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT5)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT6)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT7)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT8)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT9)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT10)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT11)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT12)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT13)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT14)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT15)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT16)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT17)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT18)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT19)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT20)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT21)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT22)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT23)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT24)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT25)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT26)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT27)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT28)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT29)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT30)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT31)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT32)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT33)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT34)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT35)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT36)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT37)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT38)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT39)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT40)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT41)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT42)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT43)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT44)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT45)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT46)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT47)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT48)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT49)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT50)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT51)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT52)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT53)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT54)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT55)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT56)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT57)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT58)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT59)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT60)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT61)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT62)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT63)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT64)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT65)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT66)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT67)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT68)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT69)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT70)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT71)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT72)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT73)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT74)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT75)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT76)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT77)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT78)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT79)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT80)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT81)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT82)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT83)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT84)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT85)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT86)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT87)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT88)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT89)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT90)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT91)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT92)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT93)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT94)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT95)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(REN0=0):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(REN0=0):_nop_());\
    ;)
/**
*******************************************************************************
* @brief       UART0 Mode Select
* @details     Set SM30
* @param[in]    __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @return      None
*  @note        None
*  @par         Example
*  @code
				__DRV_URT0_EasySetSM30(UART0_8BIT_CONFIG0)
*  @endcode
*******************************************************************************
*/


#define __DRV_URT0_EasySetSM30(__SELECT__)\
    MWT(\
		((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT1)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT2)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT3)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT4)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT5)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT6)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT7)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT8)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT9)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT10)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT11)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT12)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT13)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT14)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT15)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT16)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT17)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT18)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT19)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT20)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT21)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT22)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT23)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT24)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT25)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT26)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT27)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT28)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT29)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT30)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT31)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT32)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT33)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT34)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT35)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT36)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT37)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT38)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT39)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT40)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT41)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT42)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT43)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT44)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT45)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT46)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT47)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT48)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT49)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT50)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT51)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT52)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT53)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT54)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT55)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT56)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT57)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT58)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT59)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT60)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT61)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT62)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT63)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT64)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT65)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT66)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT67)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT68)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT69)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT70)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT71)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT72)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT73)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT74)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT75)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT76)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT77)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT78)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT79)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT80)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT81)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT82)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT83)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT84)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT85)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT86)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT87)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT88)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT89)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT90)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT91)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT92)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT93)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT94)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT95)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(S0CFG=S0CFG&~(SM30)):_nop_());\
    ;)
/**
*******************************************************************************
* @brief       UART0 Mode Select
* @details     Set SM00
* @param[in]    __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @return      None
*  @note        None
*  @par         Example
*  @code
				__DRV_URT0_EasySetSM00(UART0_8BIT_CONFIG0)
*  @endcode
*******************************************************************************
*/

#define __DRV_URT0_EasySetSM00(__SELECT__)\
    MWT(\
		((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT1)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT2)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT3)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT4)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT5)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT6)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT7)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT8)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT9)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT10)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT11)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT12)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT13)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT14)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT15)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT16)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT17)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT18)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT19)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT20)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT21)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT22)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT23)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT24)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT25)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT26)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT27)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT28)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT29)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT30)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT31)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT32)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT33)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT34)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT35)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT36)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT37)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT38)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT39)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT40)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT41)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT42)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT43)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT44)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT45)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT46)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT47)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT48)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT49)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT50)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT51)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT52)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT53)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT54)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT55)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT56)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT57)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT58)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT59)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT60)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT61)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT62)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT63)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT64)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT65)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT66)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT67)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT68)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT69)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT70)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT71)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT72)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT73)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT74)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT75)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT76)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT77)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT78)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT79)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT80)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT81)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT82)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT83)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT84)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT85)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT86)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT87)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT88)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT89)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT90)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT91)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT92)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT93)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT94)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT95)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(SM00_FE=0):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(SM00_FE=0):_nop_());\
    ;)
/**
*******************************************************************************
* @brief       UART0 Mode Select
* @details     Set SM10
* @param[in]    __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @return      None
*  @note        None
*  @par         Example
*  @code
				__DRV_URT0_EasySetSM10(UART0_8BIT_CONFIG0)
*  @endcode
*******************************************************************************
*/
#define __DRV_URT0_EasySetSM10(__SELECT__)\
    MWT(\
		((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT1)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT2)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT3)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT4)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT5)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT6)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT7)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT8)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT9)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT10)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT11)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT12)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT13)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT14)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT15)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT16)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT17)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT18)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT19)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT20)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT21)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT22)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT23)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT24)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT25)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT26)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT27)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT28)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT29)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT30)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT31)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT32)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT33)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT34)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT35)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT36)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT37)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT38)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT39)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT40)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT41)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT42)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT43)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT44)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT45)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT46)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT47)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT48)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT49)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT50)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT51)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT52)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT53)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT54)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT55)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT56)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT57)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT58)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT59)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT60)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT61)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT62)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT63)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT64)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT65)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT66)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT67)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT68)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT69)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT70)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT71)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT72)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT73)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT74)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT75)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT76)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT77)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT78)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT79)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT80)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT81)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT82)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT83)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT84)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT85)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT86)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT87)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT88)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT89)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT90)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT91)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT92)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT93)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT94)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT95)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(SM10=1):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(SM10=1):_nop_());\
    ;)


/**
*******************************************************************************
* @brief       UART0 S0CR1 Access Enable.
* @details     Set SMOD3
* @param[in]   __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @return      None
*  @note        None
*  @par         Example
*  @code
				__DRV_URT0_EasySetSMOD3(UART0_8BIT_CONFIG0)
*  @endcode
*******************************************************************************
*/
#define __DRV_URT0_EasySetSMOD3(__SELECT__)\
    MWT(\
		((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT1)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT2)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT3)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT4)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT5)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT6)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT7)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT8)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT9)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT10)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT11)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT12)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT13)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT14)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT15)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT16)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT17)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT18)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT19)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT20)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT21)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT22)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT23)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT24)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT25)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT26)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT27)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT28)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT29)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT30)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT31)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT32)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT33)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT34)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT35)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT36)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT37)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT38)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT39)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT40)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT41)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT42)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT43)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT44)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT45)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT46)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT47)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT48)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT49)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT50)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT51)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT52)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT53)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT54)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT55)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT56)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT57)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT58)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT59)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT60)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT61)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT62)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT63)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT64)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT65)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT66)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT67)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT68)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT69)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT70)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT71)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT72)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT73)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT74)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT75)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT76)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT77)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT78)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT79)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT80)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT81)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT82)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT83)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT84)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT85)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT86)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT87)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT88)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT89)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT90)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT91)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT92)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT93)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT94)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT95)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD3)):_nop_());\
    ;)
/**
*******************************************************************************
* @brief       UART0 S0BRG Clock Source
* @details     Set S0TX12
* @param[in]   __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @return      None
*  @note        Before set S0TX12 , set SMOD3=1 first
*  @par         Example
*  @code
				__DRV_URT0_EasySetS0TX12(UART0_8BIT_CONFIG0)
*  @endcode
*******************************************************************************
*/
#define __DRV_URT0_EasySetS0TX12(__SELECT__)\
    MWT(\
		((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT1)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT2)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT3)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT4)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT5)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT6)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT7)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT8)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT9)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT10)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT11)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT12)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT13)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT14)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT15)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT16)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT17)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT18)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT19)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT20)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT21)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT22)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT23)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT24)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT25)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT26)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT27)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT28)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT29)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT30)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT31)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT32)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT33)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT34)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT35)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT36)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT37)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT38)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT39)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT40)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT41)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT42)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT43)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT44)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT45)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT46)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT47)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT48)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT49)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT50)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT51)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT52)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT53)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT54)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT55)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT56)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT57)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT58)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT59)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT60)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT61)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT62)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT63)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT64)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT65)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT66)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT67)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT68)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT69)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT70)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT71)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT72)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT73)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT74)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT75)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT76)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT77)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT78)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT79)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT80)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT81)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT82)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT83)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT84)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT85)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT86)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT87)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT88)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT89)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT90)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT91)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT92)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT93)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT94)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT95)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(S0CR1=S0CR1|(S0TX12)):_nop_());\
    ;)
/**
*******************************************************************************
* @brief       UART0 Receive Clock
* @details     Set S0RCK
* @param[in]    __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @return      None
*  @note        None
*  @par         Example
*  @code
				__DRV_URT0_EasySetS0RCK(URT0_8BIT_CONFIG0)
* @endcode
*******************************************************************************
*/
#define __DRV_URT0_EasySetS0RCK(__SELECT__)\
    MWT(\
		((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT1)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT2)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT3)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT4)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT5)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT6)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT7)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT8)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT9)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT10)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT11)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT12)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT13)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT14)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT15)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT16)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT17)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT18)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT19)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT20)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT21)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT22)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT23)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT24)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT25)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT26)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT27)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT28)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT29)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT30)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT31)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT32)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT33)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT34)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT35)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT36)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT37)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT38)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT39)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT40)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT41)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT42)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT43)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT44)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT45)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT46)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT47)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT48)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT49)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT50)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT51)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT52)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT53)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT54)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT55)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT56)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT57)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT58)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT59)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT60)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT61)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT62)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT63)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT64)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT65)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT66)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT67)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT68)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT69)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT70)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT71)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT72)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT73)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT74)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT75)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT76)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT77)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT78)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT79)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT80)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT81)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT82)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT83)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT84)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT85)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT86)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT87)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT88)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT89)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT90)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT91)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT92)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT93)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT94)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT95)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(S0CR1=S0CR1&~(S0RCK)):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(S0CR1=S0CR1|(S0RCK)):_nop_());\
    ;)
/**
*******************************************************************************
* @brief       UART0 Transmit Clock
* @details     Set S0TCK
* @param[in]   __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @return      None
*  @note        None
*  @par         Example
*  @code
				___DRV_URT0_EasySetS0TCK(UART0_8BIT_CONFIG0)
*  @endcode
*******************************************************************************
*/


#define __DRV_URT0_EasySetS0TCK(__SELECT__)\
    MWT(\
		((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT1)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT2)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT3)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT4)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT5)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT6)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT7)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT8)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT9)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT10)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT11)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT12)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT13)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT14)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT15)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT16)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT17)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT18)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT19)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT20)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT21)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT22)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT23)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT24)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT25)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT26)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT27)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT28)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT29)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT30)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT31)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT32)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT33)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT34)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT35)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT36)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT37)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT38)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT39)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT40)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT41)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT42)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT43)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT44)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT45)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT46)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT47)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT48)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT49)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT50)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT51)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT52)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT53)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT54)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT55)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT56)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT57)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT58)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT59)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT60)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT61)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT62)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT63)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT64)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT65)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT66)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT67)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT68)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT69)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT70)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT71)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT72)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT73)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT74)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT75)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT76)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT77)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT78)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT79)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT80)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT81)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT82)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT83)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT84)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT85)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT86)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT87)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT88)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT89)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT90)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT91)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT92)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT93)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT94)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT95)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TCK)):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(S0CR1=S0CR1|(S0TCK)):_nop_());\
    ;)
/**
*******************************************************************************
* @brief       UART0 Data Order
* @details     Set S0DOR
* @param[in]   __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @return      None
*  @note        None
*  @par         Example
*  @code
				__DRV_URT0_EasySetS0DOR(UART0_8BIT_CONFIG0)
*  @endcode
*******************************************************************************
*/


#define __DRV_URT0_EasySetS0DOR(__SELECT__)\
    MWT(\
		((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT1)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT2)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT3)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT4)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT5)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT6)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT7)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT8)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT9)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT10)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT11)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT12)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT13)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT14)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT15)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT16)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT17)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT18)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT19)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT20)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT21)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT22)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT23)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT24)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT25)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT26)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT27)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT28)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT29)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT30)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT31)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT32)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT33)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT34)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT35)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT36)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT37)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT38)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT39)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT40)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT41)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT42)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT43)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT44)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT45)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT46)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT47)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT48)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT49)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT50)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT51)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT52)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT53)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT54)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT55)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT56)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT57)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT58)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT59)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT60)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT61)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT62)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT63)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT64)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT65)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT66)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT67)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT68)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT69)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT70)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT71)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT72)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT73)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT74)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT75)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT76)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT77)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT78)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT79)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT80)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT81)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT82)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT83)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT84)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT85)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT86)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT87)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT88)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT89)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT90)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT91)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT92)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT93)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT94)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT95)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(S0CFG=S0CFG|(S0DOR)):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(S0CFG=S0CFG&~(S0DOR)):_nop_());\
    ;)
/**
*******************************************************************************
* @brief       UART0 Enhance Baud Rate
* @details     Set SMOD1
* @param[in]    __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @return      None
*  @note        None
*  @par         Example
*  @code
				__DRV_URT0_EasySetSMOD1(UART0_8BIT_CONFIG0)
*  @endcode
*******************************************************************************
*/


#define __DRV_URT0_EasySetSMOD1(__SELECT__)\
    MWT(\
		((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT1)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT2)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT3)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT4)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT5)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT6)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT7)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT8)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT9)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT10)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT11)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT12)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT13)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT14)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT15)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT16)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT17)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT18)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT19)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT20)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT21)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT22)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT23)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT24)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT25)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT26)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT27)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT28)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT29)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT30)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT31)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT32)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT33)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT34)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT35)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT36)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT37)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT38)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT39)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT40)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT41)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT42)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT43)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT44)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT45)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT46)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT47)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT48)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT49)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT50)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT51)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT52)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT53)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT54)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT55)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT56)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT57)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT58)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT59)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT60)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT61)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT62)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT63)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT64)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT65)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT66)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT67)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT68)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT69)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT70)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT71)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT72)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT73)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT74)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT75)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT76)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT77)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT78)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT79)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT80)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT81)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT82)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT83)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT84)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT85)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT86)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT87)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT88)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT89)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT90)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT91)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT92)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT93)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT94)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT95)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(PCON0=PCON0&~(SMOD1)):_nop_());\
    ;)
/**
*******************************************************************************
* @brief       UART0 Enhance Baud Rate.
* @details     Set SMOD2
* @param[in]   __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
* @return      None
* @note        None
* @par         Example
* @code
__DRV_URT0_EasySetSMOD2(UART0_8BIT_CONFIG0)
* @endcode
*******************************************************************************
*/


#define __DRV_URT0_EasySetSMOD2(__SELECT__)\
    MWT(\
		((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT1)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT2)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT3)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT4)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT5)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT6)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT7)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT8)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT9)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT10)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT11)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT12)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT13)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT14)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT15)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT16)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT17)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT18)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT19)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT20)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT21)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT22)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT23)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT24)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT25)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT26)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT27)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT28)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT29)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT30)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT31)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT32)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT33)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT34)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT35)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT36)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT37)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT38)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT39)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT40)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT41)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT42)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT43)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT44)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT45)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT46)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT47)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT48)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT49)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT50)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT51)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT52)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT53)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT54)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT55)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT56)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT57)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT58)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT59)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT60)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT61)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT62)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT63)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT64)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT65)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT66)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT67)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT68)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT69)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT70)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT71)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT72)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT73)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT74)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT75)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT76)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT77)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT78)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT79)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT80)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT81)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT82)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT83)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT84)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT85)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT86)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT87)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT88)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT89)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT90)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT91)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT92)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT93)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT94)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT95)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(S0CFG=S0CFG|(SMOD2)):_nop_());\
    ;)
/**
*******************************************************************************
* @brief      UART0  Baud Rate Generator Reload Register
* @details    Write S0BRT
* @param[in]    __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
* @return      None
* @note        Before write S0BRT and S0BRC,S0BRG operation stop first
* @par         Example
* @code
__DRV_URT0_EasySetS0BRT(UART0_8BIT_CONFIG0)
* @endcode
*******************************************************************************
*/

///@cond __DRV_URT0_EasySetS0BRT
//                                                              //error
//#define S0BRG_BRGRL_2400_1X_12000000_12T            0xF3      // 0.16%
//#define S0BRG_BRGRL_4800_1X_11059200_12T            0xFA      // 0%
//#define S0BRG_BRGRL_9600_1X_11059200_12T            0xFD      // 0%
//#define S0BRG_BRGRL_2400_1X_12000000_1T             0x64      // 0.16%
//#define S0BRG_BRGRL_4800_1X_12000000_1T             0xB2      // 0.16%
//#define S0BRG_BRGRL_9600_1X_12000000_1T             0xD9      // 0.16%
//#define S0BRG_BRGRL_19200_1X_12000000_1T            0xEC      // -2.34%
//#define S0BRG_BRGRL_38400_1X_12000000_1T            0xF6      // -2.34%
//#define S0BRG_BRGRL_57600_1X_11059200_1T            0xFA      // 0%
//#define S0BRG_BRGRL_115200_1X_11059200_1T           0xFD      // 0%
//#define S0BRG_BRGRL_2400_2X_12000000_12T            0xE6      // 0.16%
//#define S0BRG_BRGRL_4800_2X_12000000_12T            0xF3      // 0.16%
//#define S0BRG_BRGRL_9600_2X_11059200_12T            0xFA      // 0%
//#define S0BRG_BRGRL_19200_2X_11059200_12T           0xFD      // 0%
//#define S0BRG_BRGRL_57600_2X_11059200_12T           0xFF      // 0%
//#define S0BRG_BRGRL_4800_2X_12000000_1T             0x64      // 0.16%
#define S0BRG_BRGRL_9600_2X_12000000_1T             0xB2        // 0.16%
#define S0BRG_BRGRL_19200_2X_12000000_1T            0xD9        // 0.16%
//#define S0BRG_BRGRL_38400_2X_12000000_1T            0xEC      // -2.34%
#define S0BRG_BRGRL_57600_2X_12000000_1T            0xF3        // 0.16%
#define S0BRG_BRGRL_115200_2X_12000000_1T           0xF9        // -6.99% //107142
#define S0BRG_BRGRL_115200_2X_11059200_1T           0xFA        // 0%
#define S0BRG_BRGRL_57600_2X_11059200_1T            0xF4        // 0%
#define S0BRG_BRGRL_19200_2X_11059200_1T			0xDC        // 0%
#define S0BRG_BRGRL_9600_2X_11059200_1T				0xB8		// 0%

//#define S0BRG_BRGRL_230400_2X_11059200_1T           0xFD        // 0%
//#define S0BRG_BRGRL_250000_2X_12000000_1T           0xFD        // 0%
//#define S0BRG_BRGRL_750000_2X_12000000_1T           0xFF        // 0%

//#define S0BRG_BRGRL_2400_1X_24000000_12T            0xE6        // 0.16%
//#define S0BRG_BRGRL_4800_1X_24000000_12T            0xF3        // 0.16%
//#define S0BRG_BRGRL_9600_1X_24000000_12T            0xF9        // -6.99%
//#define S0BRG_BRGRL_19200_1X_24000000_12T           0xFD        // 8.51%
//#define S0BRG_BRGRL_57600_1X_24000000_12T           0xFF        // 8.51%

//#define S0BRG_BRGRL_4800_1X_24000000_1T             0x64        // 0.16%
//#define S0BRG_BRGRL_9600_1X_24000000_1T             0xB2        // 0.16%
//#define S0BRG_BRGRL_19200_1X_24000000_1T            0xD9        // 0.16%
//#define S0BRG_BRGRL_38400_1X_24000000_1T            0xEC        // -2.34%
//#define S0BRG_BRGRL_57600_1X_24000000_1T            0xF3        // 0.16%
//#define S0BRG_BRGRL_115200_1X_24000000_1T           0xF9        // -6.99%
//#define S0BRG_BRGRL_230400_1X_24000000_1T           0xFD        // 8.51%
//#define S0BRG_BRGRL_250000_1X_24000000_1T           0xFD        // 0%
//#define S0BRG_BRGRL_750000_1X_24000000_1T           0xFF        // 0%

//#define S0BRG_BRGRL_2400_2X_24000000_12T            0xCC        // 0.16%
//#define S0BRG_BRGRL_4800_2X_24000000_12T            0xE6        // 0.16%
//#define S0BRG_BRGRL_9600_2X_24000000_12T            0xF3        // 0.16%
//#define S0BRG_BRGRL_19200_2X_24000000_12T           0xF9        // -6.99%
//#define S0BRG_BRGRL_38400_2X_24000000_12T           0xFD        // 8.51%
//#define S0BRG_BRGRL_57600_2X_24000000_12T           0xFE        // 8.51%
//#define S0BRG_BRGRL_115200_2X_24000000_12T          0xFF        // 8.51%

#define S0BRG_BRGRL_9600_2X_24000000_1T             0x64        // 0.16%
#define S0BRG_BRGRL_19200_2X_24000000_1T            0xB2        // 0.16%
//#define S0BRG_BRGRL_38400_2X_24000000_1T            0xD9        // 0.16%
#define S0BRG_BRGRL_57600_2X_24000000_1T            0xE6        // 0.16%
#define S0BRG_BRGRL_115200_2X_24000000_1T           0xF3        // 0.16%
//#define S0BRG_BRGRL_230400_2X_24000000_1T           0xF9        // -6.99%
//#define S0BRG_BRGRL_250000_2X_24000000_1T           0xFA        // 0%
//#define S0BRG_BRGRL_500000_2X_24000000_1T           0xFD        // 0%
//#define S0BRG_BRGRL_750000_2X_24000000_1T           0xFE        // 0%
//#define S0BRG_BRGRL_1500000_2X_24000000_1T          0xFF        // 0%

//#define S0BRG_BRGRL_2400_1X_32000000_12T            0xDD        // -0.79%
//#define S0BRG_BRGRL_4800_1X_32000000_12T            0xEF        // 2.12%
//#define S0BRG_BRGRL_9600_1X_32000000_12T            0xF7        // -3.55%
//#define S0BRG_BRGRL_19200_1X_32000000_12T           0xFC        // 8.51%
//#define S0BRG_BRGRL_38400_1X_32000000_12T           0xFE        // 8.51%

//#define S0BRG_BRGRL_4800_1X_32000000_1T             0x30        // 0.16%
//#define S0BRG_BRGRL_9600_1X_32000000_1T             0x98        // 0.16%
//#define S0BRG_BRGRL_19200_1X_32000000_1T            0xCC        // 0.16%
//#define S0BRG_BRGRL_38400_1X_32000000_1T            0xE6        // 0.16%
//#define S0BRG_BRGRL_57600_1X_32000000_1T            0xEF        // 2.12%
//#define S0BRG_BRGRL_115200_1X_32000000_1T           0xF7        // -3.55%
//#define S0BRG_BRGRL_230400_1X_32000000_1T           0xFC        // 8.51%
//#define S0BRG_BRGRL_250000_1X_32000000_1T           0xFC        // 0%
//#define S0BRG_BRGRL_500000_1X_32000000_1T           0xFE        // 0%
//#define S0BRG_BRGRL_1000000_1X_32000000_1T          0xFF        // 0%

//#define S0BRG_BRGRL_2400_2X_32000000_12T            0xBB        // 0.64%
//#define S0BRG_BRGRL_4800_2X_32000000_12T            0xDD        // -0.79%
//#define S0BRG_BRGRL_9600_2X_32000000_12T            0xEF        // 2.12%
//#define S0BRG_BRGRL_19200_2X_32000000_12T           0xF7        // -3.55%
//#define S0BRG_BRGRL_38400_2X_32000000_12T           0xFC        // 8.51%
//#define S0BRG_BRGRL_57600_2X_32000000_12T           0xFD        // -3.55%

#define S0BRG_BRGRL_9600_2X_32000000_1T             0x30        // 0.16%
#define S0BRG_BRGRL_19200_2X_32000000_1T            0x98        // 0.16%
//#define S0BRG_BRGRL_38400_2X_32000000_1T            0xCC        // 0.16%
#define S0BRG_BRGRL_57600_2X_32000000_1T            0xDD        // -0.79%
#define S0BRG_BRGRL_115200_2X_32000000_1T           0xEF        // 2.12%
//#define S0BRG_BRGRL_230400_2X_32000000_1T           0xF7        // -3.55%
//#define S0BRG_BRGRL_250000_2X_32000000_1T           0xF8        // 0%
//#define S0BRG_BRGRL_500000_2X_32000000_1T           0xFC        // 0%
//#define S0BRG_BRGRL_1000000_2X_32000000_1T          0xFE        // 0%

//#define S0BRG_BRGRL_9600_1X_36000000_12T            0xF6        //9375// -2.3%
//#define S0BRG_BRGRL_19200_1X_36000000_12T           0xFB        //18750// -2.3%

//#define S0BRG_BRGRL_19200_1X_36000000_1T            0xC5        //19068// -0.69%
//#define S0BRG_BRGRL_57600_1X_36000000_1T            0xEC        //56250// -2.3%
//#define S0BRG_BRGRL_115200_1X_36000000_1T           0xF6        //112500// -2.3%

//#define S0BRG_BRGRL_9600_2X_36000000_12T            0xEC        //9375// -2.3%
//#define S0BRG_BRGRL_19200_2X_36000000_12T           0xF6        //18750// -2.3%
//#define S0BRG_BRGRL_57600_2X_36000000_12T           0xFD        //62500// 8.5%

#define S0BRG_BRGRL_9600_2X_36000000_1T             0x16        // 0.16% //9615
#define S0BRG_BRGRL_19200_2X_36000000_1T            0x8B        // 0.16% //19231
#define S0BRG_BRGRL_57600_2X_36000000_1T            0xD9        // 0.16% //57692
#define S0BRG_BRGRL_115200_2X_36000000_1T           0xEC        // -2.3% //112500

//#define S0BRG_BRGRL_2400_1X_48000000_12T            0xCC        // 0.16%
//#define S0BRG_BRGRL_4800_1X_48000000_12T            0xE6        // 0.16%
//#define S0BRG_BRGRL_9600_1X_48000000_12T            0xF3        // 0.16%
//#define S0BRG_BRGRL_19200_1X_48000000_12T           0xF9        // -6.99%
//#define S0BRG_BRGRL_38400_1X_48000000_12T           0xFD        // 8.51%
//#define S0BRG_BRGRL_57600_1X_48000000_12T           0xFE        // 8.51%
//#define S0BRG_BRGRL_115200_1X_48000000_12T          0xFF        // 8.51%

//#define S0BRG_BRGRL_9600_1X_48000000_1T             0x64        // 0.16%
//#define S0BRG_BRGRL_19200_1X_48000000_1T            0xB2        // 0.16%
//#define S0BRG_BRGRL_38400_1X_48000000_1T            0xD9        // 0.16%
//#define S0BRG_BRGRL_57600_1X_48000000_1T            0xE6        // 0.16%
//#define S0BRG_BRGRL_115200_1X_48000000_1T           0xF3        // 0.16%
//#define S0BRG_BRGRL_230400_1X_48000000_1T           0xF9        // -6.99%
//#define S0BRG_BRGRL_250000_1X_48000000_1T           0xFA        // 0%
//#define S0BRG_BRGRL_500000_1X_48000000_1T           0xFD        // 0%
//#define S0BRG_BRGRL_750000_1X_48000000_1T           0xFE        // 0%
//#define S0BRG_BRGRL_1500000_1X_48000000_1T          0xFF        // 0%

//#define S0BRG_BRGRL_2400_2X_48000000_12T            0x98        // 0.16%
//#define S0BRG_BRGRL_4800_2X_48000000_12T            0xCC        // 0.16%
//#define S0BRG_BRGRL_9600_2X_48000000_12T            0xE6        // 0.16%
//#define S0BRG_BRGRL_19200_2X_48000000_12T           0xF3        // 0.16%
//#define S0BRG_BRGRL_38400_2X_48000000_12T           0xF9        // -6.99%
//#define S0BRG_BRGRL_57600_2X_48000000_12T           0xFC        // 8.51%
//#define S0BRG_BRGRL_115200_2X_48000000_12T          0xFE        // 8.51%
//#define S0BRG_BRGRL_230400_2X_48000000_12T          0xFF        // 8.51%
//#define S0BRG_BRGRL_250000_2X_48000000_12T          0xFF        // 0%

#define S0BRG_BRGRL_19200_2X_48000000_1T            0x64        // 0.16%
//#define S0BRG_BRGRL_38400_2X_48000000_1T            0xB2        // 0.16%
#define S0BRG_BRGRL_57600_2X_48000000_1T            0xCC        // 0.16%
#define S0BRG_BRGRL_115200_2X_48000000_1T           0xE6        // 0.16%
//#define S0BRG_BRGRL_230400_2X_48000000_1T           0xF3        // 0.16%
//#define S0BRG_BRGRL_250000_2X_48000000_1T           0xF4        // 0%
//#define S0BRG_BRGRL_500000_2X_48000000_1T           0xFA        // 0%
//#define S0BRG_BRGRL_750000_2X_48000000_1T           0xFC        // 0%
//#define S0BRG_BRGRL_1000000_2X_48000000_1T          0xFD        // 0%
//#define S0BRG_BRGRL_1500000_2X_48000000_1T          0xFE        // 0%
//#define S0BRG_BRGRL_3000000_2X_48000000_1T          0xFF        // 0%

//#define S0BRG_BRGRL_2400_1X_22118400_12T            0xE8        // 0%
//#define S0BRG_BRGRL_4800_1X_22118400_12T            0xF4        // 0%
//#define S0BRG_BRGRL_9600_1X_22118400_12T            0xFA        // 0%
//#define S0BRG_BRGRL_19200_1X_22118400_12T           0xFD        // 0%
//#define S0BRG_BRGRL_57600_1X_22118400_12T           0xFF        // 0%

//#define S0BRG_BRGRL_4800_1X_22118400_1T             0x70        // 0%
//#define S0BRG_BRGRL_9600_1X_22118400_1T             0xB8        // 0%
//#define S0BRG_BRGRL_19200_1X_22118400_1T            0xDC        // 0%
//#define S0BRG_BRGRL_38400_1X_22118400_1T            0xEE        // 0%
//#define S0BRG_BRGRL_57600_1X_22118400_1T            0xF4        // 0%
//#define S0BRG_BRGRL_115200_1X_22118400_1T           0xFA        // 0%
//#define S0BRG_BRGRL_230400_1X_22118400_1T           0xFD        // 0%
//#define S0BRG_BRGRL_691200_1X_22118400_1T           0xFF        // 0%

//#define S0BRG_BRGRL_2400_2X_22118400_12T            0xD0        // 0%
//#define S0BRG_BRGRL_4800_2X_22118400_12T            0xE8        // 0%
//#define S0BRG_BRGRL_9600_2X_22118400_12T            0xF4        // 0%
//#define S0BRG_BRGRL_19200_2X_22118400_12T           0xFA        // 0%
//#define S0BRG_BRGRL_38400_2X_22118400_12T           0xFD        // 0%
//#define S0BRG_BRGRL_57600_2X_22118400_12T           0xFE        // 0%
//#define S0BRG_BRGRL_115200_2X_22118400_12T          0xFF        // 0%

#define S0BRG_BRGRL_9600_2X_22118400_1T             0x70        // 0%
#define S0BRG_BRGRL_19200_2X_22118400_1T            0xB8        // 0%
//#define S0BRG_BRGRL_38400_2X_22118400_1T            0xDC        // 0%
#define S0BRG_BRGRL_57600_2X_22118400_1T            0xE8        // 0%
#define S0BRG_BRGRL_115200_2X_22118400_1T           0xF4        // 0%
//#define S0BRG_BRGRL_230400_2X_22118400_1T           0xFA        // 0%
//#define S0BRG_BRGRL_460800_2X_22118400_1T           0xFD        // 0%
//#define S0BRG_BRGRL_691200_2X_22118400_1T           0xFE        // 0%
//#define S0BRG_BRGRL_1382400_2X_22118400_1T          0xFF        // 0%


//#define S0BRG_BRGRL_2400_1X_29491200_12T            0xE0        // 0%
//#define S0BRG_BRGRL_4800_1X_29491200_12T            0xF0        // 0%
//#define S0BRG_BRGRL_9600_1X_29491200_12T            0xF8        // 0%
//#define S0BRG_BRGRL_19200_1X_29491200_12T           0xFC        // 0%
//#define S0BRG_BRGRL_76800_1X_29491200_12T           0xFF        // 0%

//#define S0BRG_BRGRL_4800_1X_29491200_1T             0x40        // 0%
//#define S0BRG_BRGRL_9600_1X_29491200_1T             0xA0        // 0%
//#define S0BRG_BRGRL_19200_1X_29491200_1T            0xD0        // 0%
//#define S0BRG_BRGRL_38400_1X_29491200_1T            0xE8        // 0%
//#define S0BRG_BRGRL_57600_1X_29491200_1T            0xF0        // 0%
//#define S0BRG_BRGRL_115200_1X_29491200_1T           0xF8        // 0%
//#define S0BRG_BRGRL_230400_1X_29491200_1T           0xFC        // 0%
//#define S0BRG_BRGRL_921600_1X_29491200_1T           0xFF        // 0%

//#define S0BRG_BRGRL_2400_2X_29491200_12T            0xC0        // 0%
//#define S0BRG_BRGRL_4800_2X_29491200_12T            0xE0        // 0%
//#define S0BRG_BRGRL_9600_2X_29491200_12T            0xF0        // 0%
//#define S0BRG_BRGRL_19200_2X_29491200_12T           0xF8        // 0%

#define S0BRG_BRGRL_9600_2X_29491200_1T             0x40        // 0%
#define S0BRG_BRGRL_19200_2X_29491200_1T            0xA0        // 0%
//#define S0BRG_BRGRL_38400_2X_29491200_1T            0xD0        // 0%
#define S0BRG_BRGRL_57600_2X_29491200_1T            0xE0        // 0%
#define S0BRG_BRGRL_115200_2X_29491200_1T           0xF0        // 0%
//#define S0BRG_BRGRL_230400_2X_29491200_1T           0xF8        // 0%
//#define S0BRG_BRGRL_460800_2X_29491200_1T           0xFD        // 0%
//#define S0BRG_BRGRL_921600_2X_29491200_1T           0xFE        // 0%

//#define S0BRG_BRGRL_2400_1X_33177600_12T            0xDC        // 0%
//#define S0BRG_BRGRL_4800_1X_33177600_12T            0xEE        // 0%
//#define S0BRG_BRGRL_9600_1X_33177600_12T            0xF7        // 0%

//#define S0BRG_BRGRL_4800_1X_33177600_1T             0x28        // 0%
//#define S0BRG_BRGRL_9600_1X_33177600_1T             0x94        // 0%
//#define S0BRG_BRGRL_19200_1X_33177600_1T            0xCA        // 0%
//#define S0BRG_BRGRL_38400_1X_33177600_1T            0xE5        // 0%
//#define S0BRG_BRGRL_57600_1X_331776600_1T            0xEE        // 0%
//#define S0BRG_BRGRL_115200_1X_331776600_1T           0xF7        // 0%

//#define S0BRG_BRGRL_2400_2X_33177600_12T            0xB8        // 0%
//#define S0BRG_BRGRL_4800_2X_33177600_12T            0xDC        // 0%
//#define S0BRG_BRGRL_9600_2X_33177600_12T            0xEE        // 0%
//#define S0BRG_BRGRL_19200_2X_33177600_12T           0xF7        // 0%

#define S0BRG_BRGRL_9600_2X_33177600_1T             0x28        // 0%
#define S0BRG_BRGRL_19200_2X_33177600_1T            0x94        // 0%
//#define S0BRG_BRGRL_38400_2X_33177600_1T            0xCA        // 0%
#define S0BRG_BRGRL_57600_2X_33177600_1T            0xDC        // 0%
#define S0BRG_BRGRL_115200_2X_33177600_1T           0xEE        // 0%
//#define S0BRG_BRGRL_230400_2X_33177600_1T           0xF7        // 0%

//#define S0BRG_BRGRL_2400_1X_44236800_12T            0xA0        // 0%
//#define S0BRG_BRGRL_4800_1X_44236800_12T            0xE8        // 0%
//#define S0BRG_BRGRL_9600_1X_44236800_12T            0xF4        // 0%
//#define S0BRG_BRGRL_19200_1X_44236800_12T           0xFA        // 0%
//#define S0BRG_BRGRL_57600_1X_44236800_12T           0xFE        // 0%

//#define S0BRG_BRGRL_9600_1X_44236800_1T             0x70        // 0%
//#define S0BRG_BRGRL_19200_1X_44236800_1T            0xB8        // 0%
//#define S0BRG_BRGRL_38400_1X_44236800_1T            0xDC        // 0%
//#define S0BRG_BRGRL_57600_1X_44236800_1T            0xE8        // 0%
//#define S0BRG_BRGRL_115200_1X_44236800_1T           0xF4        // 0%
//#define S0BRG_BRGRL_230400_1X_44236800_1T           0xFA        // 0%

//#define S0BRG_BRGRL_2400_2X_44236800_12T            0xA0        // 0%
//#define S0BRG_BRGRL_4800_2X_44236800_12T            0xD0        // 0%
//#define S0BRG_BRGRL_9600_2X_44236800_12T            0xE8        // 0%
//#define S0BRG_BRGRL_19200_2X_44236800_12T           0xF4        // 0%
//#define S0BRG_BRGRL_38400_2X_44236800_12T           0xFA        // 0%
//#define S0BRG_BRGRL_57600_2X_44236800_12T           0xFC        // 0%
//#define S0BRG_BRGRL_115200_2X_44236800_12T          0xFE        // 0%

#define S0BRG_BRGRL_19200_2X_44236800_1T            0x70        // 0%
//#define S0BRG_BRGRL_38400_2X_44236800_1T            0xB8        // 0%
#define S0BRG_BRGRL_57600_2X_44236800_1T            0xD0        // 0%
#define S0BRG_BRGRL_115200_2X_44236800_1T           0xE8        // 0%
//#define S0BRG_BRGRL_230400_2X_44236800_1T           0xF4        // 0%
//#define S0BRG_BRGRL_460800_2X_44236800_1T           0xFA        // 0%


///@endcond

#define __DRV_URT0_EasySetS0BRT(__SELECT__)\
    MWT(\
		((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT1)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT2)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT3)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT4)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT5)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT6)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT7)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT8)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT9)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT10)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT11)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT12)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT13)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT14)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT15)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT16)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT17)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT18)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT19)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT20)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT21)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT22)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT23)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT24)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT25)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT26)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT27)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT28)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT29)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT30)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT31)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT32)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT33)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT34)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT35)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT36)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT37)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT38)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT39)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT40)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT41)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT42)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT43)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT44)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT45)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT46)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT47)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT48)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT49)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT50)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT51)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT52)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT53)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT54)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT55)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT56)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT57)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT58)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT59)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT60)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT61)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT62)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT63)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT64)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT65)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT66)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT67)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT68)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT69)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT70)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT71)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT72)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT73)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT74)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT75)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT76)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT77)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT78)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT79)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT80)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT81)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT82)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT83)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT84)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT85)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT86)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT87)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT88)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT89)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT90)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT91)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT92)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT93)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT94)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT95)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_115200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_57600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_19200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(S0BRT=S0BRG_BRGRL_9600_2X_33177600_1T):_nop_());\
    ;)
/**
*******************************************************************************
* @brief      UART0  Baud Rate Generator Reload Register
* @details    Write S0BRC
* @param[in]  __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
* @return      None
* @note        Before write S0BRT and S0BRC,S0BRG operation stop first
* @par         Example
* @code
__DRV_URT0_EasySetS0BRC(UART0_8BIT_CONFIG0)
* @endcode
*******************************************************************************
*/


#define __DRV_URT0_EasySetS0BRC(__SELECT__)\
    MWT(\
		((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT1)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT2)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT3)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT4)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT5)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT6)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT7)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT8)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT9)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT10)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT11)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT12)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT13)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT14)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT15)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT16)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT17)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT18)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT19)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT20)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT21)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT22)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT23)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_12000000_1T):\
		(__SELECT__^UART0_SELECT24)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT25)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT26)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT27)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT28)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT29)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT30)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT31)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT32)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT33)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT34)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT35)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT36)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT37)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT38)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT39)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT40)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT41)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT42)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT43)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT44)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT45)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT46)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT47)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_11059200_1T):\
		(__SELECT__^UART0_SELECT48)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT49)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT50)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT51)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT52)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT53)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT54)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT55)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT56)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT57)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT58)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT59)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT60)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT61)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT62)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT63)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT64)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT65)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT66)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT67)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT68)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT69)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT70)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT71)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_24000000_1T):\
		(__SELECT__^UART0_SELECT72)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT73)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT74)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT75)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT76)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT77)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT78)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT79)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT80)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT81)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT82)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT83)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT84)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT85)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT86)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT87)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT88)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT89)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT90)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT91)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT92)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT93)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT94)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT95)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_22118400_1T):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_29491200_1T):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_115200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_57600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_19200_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_33177600_1T):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(S0BRC=S0BRG_BRGRL_9600_2X_33177600_1T):_nop_());\
    ;)
/**
*******************************************************************************
* @brief       UART0 S0BRG Operation Enable
* @details     Set S0TR
* @param[in]   __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
* @return      None
* @note        Before write S0BRT and S0BRC,S0BRG operation stop first
* @par         Example
* @code
__DRV_URT0_EasySetS0TR_Start(UART0_8BIT_CONFIG0)
* @endcode
*******************************************************************************
*/


#define __DRV_URT0_EasySetS0TR_Start(__SELECT__)\
    MWT(\
		((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT1)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT2)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT3)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT4)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT5)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT6)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT7)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT8)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT9)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT10)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT11)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT12)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT13)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT14)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT15)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT16)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT17)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT18)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT19)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT20)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT21)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT22)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT23)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT24)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT25)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT26)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT27)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT28)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT29)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT30)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT31)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT32)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT33)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT34)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT35)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT36)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT37)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT38)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT39)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT40)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT41)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT42)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT43)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT44)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT45)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT46)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT47)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT48)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT49)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT50)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT51)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT52)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT53)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT54)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT55)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT56)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT57)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT58)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT59)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT60)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT61)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT62)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT63)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT64)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT65)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT66)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT67)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT68)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT69)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT70)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT71)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT72)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT73)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT74)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT75)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT76)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT77)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT78)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT79)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT80)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT81)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT82)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT83)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT84)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT85)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT86)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT87)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT88)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT89)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT90)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT91)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT92)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT93)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT94)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT95)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(S0CR1=S0CR1|(S0TR)):_nop_());\ 
    ;)
/**
*******************************************************************************
* @brief       UART0 S0BRG Operation Disable
* @details     Set S0TR
* @param[in]    __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
* @return      None
* @note        Before write S0BRT and S0BRC,S0BRG operation stop first
* @par         Example
* @code
__DRV_URT0_EasySetS0TR_Stop(UART0_8BIT_CONFIG0)
* @endcode
*******************************************************************************
*/


#define __DRV_URT0_EasySetS0TR_Stop(__SELECT__)\
    MWT(\
		((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT1)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT2)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT3)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT4)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT5)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT6)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT7)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT8)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT9)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT10)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT11)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT12)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT13)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT14)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT15)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT16)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT17)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT18)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT19)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT20)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT21)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT22)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT23)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT24)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT25)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT26)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT27)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT28)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT29)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT30)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT31)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT32)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT33)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT34)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT35)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT36)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT37)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT38)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT39)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT40)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT41)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT42)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT43)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT44)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT45)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT46)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT47)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT48)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT49)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT50)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT51)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT52)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT53)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT54)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT55)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT56)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT57)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT58)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT59)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT60)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT61)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT62)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT63)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT64)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT65)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT66)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT67)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT68)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT69)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT70)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT71)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT72)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT73)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT74)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT75)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT76)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT77)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT78)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT79)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT80)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT81)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT82)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT83)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT84)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT85)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT86)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT87)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT88)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT89)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT90)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT91)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT92)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT93)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT94)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT95)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(S0CR1=S0CR1&~(S0TR)):_nop_());\	
    ;)
/**
*******************************************************************************
* @brief       UART0 Pin Config
* @details     Set S0PS0
* @param[in]    __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
* @return      None
* @note        None
* @par         Example
* @code
__DRV_URT0_EasySetS0PS0(UART0_8BIT_CONFIG0)
* @endcode
*******************************************************************************
*/


#define __DRV_URT0_EasySetS0PS0(__SELECT__)\
    MWT(\
		((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT1)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT2)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT3)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT4)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT5)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT6)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT7)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT8)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT9)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT10)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT11)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT12)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT13)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT14)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT15)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT16)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT17)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT18)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT19)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT20)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT21)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT22)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT23)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT24)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT25)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT26)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT27)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT28)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT29)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT30)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT31)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT32)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT33)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT34)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT35)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT36)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT37)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT38)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT39)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT40)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT41)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT42)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT43)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT44)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT45)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT46)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT47)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT48)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT49)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT50)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT51)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT52)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT53)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT54)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT55)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT56)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT57)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT58)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT59)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT60)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT61)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT62)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT63)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT64)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT65)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT66)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT67)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT68)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT69)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT70)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT71)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT72)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT73)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT74)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT75)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT76)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT77)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT78)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT79)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT80)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT81)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT82)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT83)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT84)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT85)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT86)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT87)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT88)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT89)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT90)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT91)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT92)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT93)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT94)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT95)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(AUXR3=AUXR3&~(S0PS0)):_nop_());\
    ;)
/**
*******************************************************************************
* @brief       UART0 Pin Config
* @details     Set S0PS1
* @param[in]   __SELECT__ :
*  @arg\b       UART0_8BIT_CONFIG0 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG1 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG2 : 9600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG3 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG4 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG5 : 9600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG6 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG7 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG8 : 19200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG9 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG10 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG11 : 19200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG12 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG13 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG14 : 57600 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG15 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG16 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG17 : 57600 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG18 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG19 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG20 : 115200 12MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG21 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG22 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG23 : 115200 12MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG24 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG25 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG26 : 115200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG27 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG28 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG29 : 115200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG30 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG31 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG32 : 57600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG33 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG34 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG35 : 57600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG36 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG37 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG38 : 19200 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG39 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG40 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG41 : 19200 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG42 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG43 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG44 : 9600 11.0592MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG45 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG46 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG47 : 9600 11.0592MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG48 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG49 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG50 : 9600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG51 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG52 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG53 : 9600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG54 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG55 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG56 : 19200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG57 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG58 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG59 : 19200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG60 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG61 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG62 : 57600 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG63 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG64 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG65 : 57600 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG66 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG67 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG68 : 115200 24MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG69 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG70 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG71 : 115200 24MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG72 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG73 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG74 : 115200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG75 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG76 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG77 : 115200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG78 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG79 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG80 : 57600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG81 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG82 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG83 : 57600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG84 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG85 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG86 : 19200 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG87 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG88 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG89 : 19200 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG90 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG91 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG92 : 9600 22.1184MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG93 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG94 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG95 : 9600 22.1184MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG96 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG97 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG98 : 9600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG99 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG100 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG101 : 9600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG102 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG103 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG104 : 19200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG105 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG106 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG107 : 19200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG108 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG109 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG110 : 57600 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG111 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG112 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG113 : 57600 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG114 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG115 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG116 : 115200 29.4912MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG117 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG118 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG119 : 115200 29.4912MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG120 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG121 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG122 : 115200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG123 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG124 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG125 : 115200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG126 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG127 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG128 : 57600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG129 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG130 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG131 : 57600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG132 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG133 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG134 : 19200  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG135 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG136 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG137 : 19200  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG138 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG139 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG140 : 9600  33.1776MHz 8bit LSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG141 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG142 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Rx only SYSCLK/1 double baud rate S0BRG
*  @arg\b       UART0_8BIT_CONFIG143 : 9600  33.1776MHz 8bit MSB Rx p30 Tx p31 Tx/Rx both SYSCLK/1 double baud rate S0BRG
* @return      None
* @note        None
* @par         Example
* @code
__DRV_URT0_EasySetS0PS1(UART0_8BIT_CONFIG0)
* @endcode
*******************************************************************************
*/

#define __DRV_URT0_EasySetS0PS1(__SELECT__)\
    MWT(\
        __DRV_SFR_PageIndex(AUXR10_Page);\
		((__SELECT__^UART0_SELECT0)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT1)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT2)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT3)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT4)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT5)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT6)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT7)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT8)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT9)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT10)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT11)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT12)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT13)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT14)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT15)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT16)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT17)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT18)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT19)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT20)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT21)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT22)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT23)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT24)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT25)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT26)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT27)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT28)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT29)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT30)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT31)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT32)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT33)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT34)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT35)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT36)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT37)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT38)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT39)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT40)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT41)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT42)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT43)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT44)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT45)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT46)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT47)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT48)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT49)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT50)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT51)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT52)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT53)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT54)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT55)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT56)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT57)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT58)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT59)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT60)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT61)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT62)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT63)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT64)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT65)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT66)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT67)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT68)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT69)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT70)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT71)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT72)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT73)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT74)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT75)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT76)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT77)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT78)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT79)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT80)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT81)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT82)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT83)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT84)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT85)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT86)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT87)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT88)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT89)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT90)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT91)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT92)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT93)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT94)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT95)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT96)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT97)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT98)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT99)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT100)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT101)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT102)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT103)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT104)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT105)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT106)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT107)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT108)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT109)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT110)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT111)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT112)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT113)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT114)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT115)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT116)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT117)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT118)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT119)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT120)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT121)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT122)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT123)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT124)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT125)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT126)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT127)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT128)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT129)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT130)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT131)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT132)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT133)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT134)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT135)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT136)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT137)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT138)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT139)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT140)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT141)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT142)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):\
		(__SELECT__^UART0_SELECT143)==OPTION_MATCH?(AUXR10=AUXR10&~(S0PS1)):_nop_());\
        __DRV_SFR_PageIndex(0);\
    ;)
#endif  //MG82F6D64_UART0_MID_H



